package org.start.data;

import org.start.print;

import java.util.HashMap;
import java.util.Map;

public class TeamManager {

    // 存储玩家名称与队伍的关系
    private static Map<String, String> playerTeamMap = new HashMap<>();

    /**
     * 设置玩家的队伍类型
     *
     * @param playerName 玩家名称
     * @param teamType   队伍类型
     */
    public static void setPlayer(String playerName, String teamType) {
        playerTeamMap.put(playerName, teamType);
        print.command_p("i", "玩家"+ playerName + "加入" + teamType);
    }

    /**
     * 获取玩家当前的队伍类型
     *
     * @param playerName 玩家名称
     * @return 队伍类型，如果玩家不在任何队伍中则返回 null
     */
    public static String getPlayer(String playerName) {
        return playerTeamMap.get(playerName);
    }

    /**
     * 检查玩家是否已经加入了队伍
     *
     * @param playerName 玩家名称
     * @return 如果玩家已经加入了队伍，返回 true，否则返回 false
     */
    public static boolean isPlayerInTeam(String playerName) {
        return playerTeamMap.containsKey(playerName);
    }

    /**
     * 移除玩家的队伍类型
     *
     * @param playerName 玩家名称
     */
    public static boolean removePlayer(String playerName) {
        if (playerTeamMap.containsKey(playerName)) {
            playerTeamMap.remove(playerName);
            print.command_p("i" ,"玩家 " + playerName + " 已退出队伍");
            return true;
        } else {
            return false;
        }
    }
}
