package org.start.player.bossbar;

import org.bukkit.boss.BarStyle;
import org.bukkit.boss.BarColor;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.HashMap;
import java.util.Map;

public class manger {

    private JavaPlugin plugin;  // 插件实例
    private Map<String, BossBar> playerBossBars = new HashMap<>();  // 存储玩家的进度条

    public manger(JavaPlugin plugin) {
        this.plugin = plugin;
    }

    // 为玩家创建进度条，并将其加入对应队伍的进度条
    public void addPlayerProgress(Player player, String team) {
        // 如果玩家已经有进度条，先移除
        removePlayerProgress(player);

        // 创建进度条
        BossBar bossBar = plugin.getServer().createBossBar("", BarColor.RED, BarStyle.SOLID);

        // 根据队伍设置进度条标题
        if (team.equals("red")) {
            bossBar.setTitle("Red Team Progress");
        } else if (team.equals("blue")) {
            bossBar.setTitle("Blue Team Progress");
        }

        // 设置初始进度为 0
        bossBar.setProgress(0.0);

        // 显示进度条
        bossBar.addPlayer(player);

        // 存储玩家的进度条
        playerBossBars.put(player.getName(), bossBar);
    }

    // 移除玩家的进度条
    public void removePlayerProgress(Player player) {
        BossBar bossBar = playerBossBars.get(player.getName());
        if (bossBar != null) {
            bossBar.removePlayer(player);
            playerBossBars.remove(player.getName());
        }
    }

    // 更新所有玩家的进度条
    public void updateProgress(String team, double progress) {
        // 遍历所有玩家，并更新其队伍对应的进度条
        for (Player player : plugin.getServer().getOnlinePlayers()) {
            if (team.equals("red")) {
                // 红队的进度条
                BossBar bossBar = playerBossBars.get(player.getName());
                if (bossBar != null) {
                    bossBar.setProgress(progress);
                }
            } else if (team.equals("blue")) {
                // 蓝队的进度条
                BossBar bossBar = playerBossBars.get(player.getName());
                if (bossBar != null) {
                    bossBar.setProgress(1.0 - progress);  // 蓝队失守进度
                }
            }
        }
    }
}
