package org.start.player.main;

//          ----------- > > >  本类是插件核心调度类 < < < ------------

//     统管bossbar模块，用于控制玩家
//     管玩家区域事件，监听玩家是否位于某一区域

import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.start.player.bossbar.boss_bar_runs;
import org.start.player.main.model.redAtEvent;
import org.start.player.main.model.shi_fo_at;
import org.start.print;


public class run_{

    private JavaPlugin plugin;  // 插件实例，用于访问服务器的API
    private double redTeamProgress = 0;  // 红队的进攻进度（0-100），初始为0
    private boolean gameEnded = false;  // 游戏是否已经结束的标志
    private static boolean b;  //用于判断是否有玩家在目标位置 

    public run_(JavaPlugin plugin) {
        this.plugin = plugin;
        plugin.getLogger().info("run_ 类初始化已完成");
        _start();  // 启动任务
    }
    
    // 开始定时检查红队进攻进度的任务
    public void _start() {
        print.command_p( "i","计时任务正在运行");
        new shi_fo_at();  // 初始化判断类
        new redAtEvent().first();  //初始化，防止出错

        // 每1秒钟检查一次红队玩家是否在目标区域
        new BukkitRunnable() {

            @Override
            public void run() {

                // 如果游戏已经结束，停止定时任务
                if (gameEnded) {
                    cancel();  // 停止任务
                    return;
                }
                int redTeamPlayersInArea = 0;
                // 遍历所有在线玩家，检查红队玩家是否在目标区域
                for (Player player : plugin.getServer().getOnlinePlayers()) {
                    if (shi_fo_at.isPlayerInRegion(player)) {
                        b = true;
                    }
                }
                
                if (b){
                    b = false;
                    redAtEvent.setB1(true);
                    redTeamPlayersInArea++;  // 如果红队玩家在区域内，计数器加1
                    boss_bar_runs.onRedTeamProgressChanged(redTeamProgress);
                }else {
                    redAtEvent.setB1(false);
                }
                
                
                // 如果有红队玩家在目标区域，增加进度
                if (redTeamPlayersInArea > 0) {
                    redTeamProgress = Math.min(redTeamProgress + 0.5, 100);  // 红队进度加1，最大为100
                    // 如果红队进度达到100，游戏结束
                    if (redTeamProgress == 100) {
                        gameOver();
                    }
                }
            }
        }.runTaskTimer(plugin, 0L, 10L);  // 0L 延迟，20L 间隔，表示每1秒执行一次
    }

    // 游戏结束，触发游戏结束相关操作
    private void gameOver() {
        gameEnded = true;  // 标记游戏已结束
        plugin.getServer().broadcastMessage("游戏结束！红队胜利！");  // 广播游戏结束消息
    }
}

